Index: trunk/LMDZ.COMMON/libf/dyn3d/vlspltqs.F
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d/vlspltqs.F	(revision 1507)
+++ trunk/LMDZ.COMMON/libf/dyn3d/vlspltqs.F	(revision 1508)
@@ -1,7 +1,8 @@
-!
-! $Header$
-!
+c
+c $Id: vlspltqs.F 2286 2015-05-20 13:27:07Z emillour $
+c
        SUBROUTINE vlspltqs ( q,pente_max,masse,w,pbaru,pbarv,pdt,
-     ,                                  p,pk,teta                 )
+     ,                                  p,pk,teta,iq             )
+       USE infotrac, ONLY: nqtot,nqdesc,iqfils
 c
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget, F.Codron 
@@ -33,7 +34,8 @@
       REAL masse(ip1jmp1,llm),pente_max
       REAL pbaru( ip1jmp1,llm ),pbarv( ip1jm,llm)
-      REAL q(ip1jmp1,llm)
+      REAL q(ip1jmp1,llm,nqtot)
       REAL w(ip1jmp1,llm),pdt
       REAL p(ip1jmp1,llmp1),teta(ip1jmp1,llm),pk(ip1jmp1,llm)
+      INTEGER iq ! CRisi
 c
 c      Local 
@@ -41,11 +43,12 @@
 c
       INTEGER i,ij,l,j,ii
+      INTEGER ifils,iq2 ! CRisi
 c
       REAL qsat(ip1jmp1,llm)
-      REAL zm(ip1jmp1,llm)
+      REAL zm(ip1jmp1,llm,nqtot)
       REAL mu(ip1jmp1,llm)
       REAL mv(ip1jm,llm)
       REAL mw(ip1jmp1,llm+1)
-      REAL zq(ip1jmp1,llm)
+      REAL zq(ip1jmp1,llm,nqtot)
       REAL temps1,temps2,temps3
       REAL zzpbar, zzw
@@ -63,5 +66,4 @@
       REAL rtt,retv,r2es,r3les,r3ies,r4les,r4ies,play
       REAL ptarg,pdelarg,foeew,zdelta
-! ADAPTATION GCM POUR CP(T)
       REAL tempe(ip1jmp1,llm)
 
@@ -115,31 +117,33 @@
       ENDDO
 
-      CALL SCOPY(ijp1llm,q,1,zq,1)
-      CALL SCOPY(ijp1llm,masse,1,zm,1)
+      CALL SCOPY(ijp1llm,q(1,1,iq),1,zq(1,1,iq),1)
+      CALL SCOPY(ijp1llm,masse,1,zm(1,1,iq),1)
+      if (nqdesc(iq).gt.0) then  
+       do ifils=1,nqdesc(iq)
+        iq2=iqfils(ifils,iq)
+        CALL SCOPY(ijp1llm,q(1,1,iq2),1,zq(1,1,iq2),1)
+       enddo  
+      endif !if (nqfils(iq).gt.0) then
 
 c      call minmaxq(zq,qmin,qmax,'avant vlxqs     ')
-      call vlxqs(zq,pente_max,zm,mu,qsat)
-
+      call vlxqs(zq,pente_max,zm,mu,qsat,iq)
 
 c     call minmaxq(zq,qmin,qmax,'avant vlyqs     ')
 
-      call vlyqs(zq,pente_max,zm,mv,qsat)
-
+      call vlyqs(zq,pente_max,zm,mv,qsat,iq)
 
 c      call minmaxq(zq,qmin,qmax,'avant vlz     ')
 
-      call vlz(zq,pente_max,zm,mw)
-
+      call vlz(zq,pente_max,zm,mw,iq)
 
 c     call minmaxq(zq,qmin,qmax,'avant vlyqs     ')
 c     call minmaxq(zm,qmin,qmax,'M avant vlyqs     ')
 
-      call vlyqs(zq,pente_max,zm,mv,qsat)
-
+      call vlyqs(zq,pente_max,zm,mv,qsat,iq)
 
 c     call minmaxq(zq,qmin,qmax,'avant vlxqs     ')
 c     call minmaxq(zm,qmin,qmax,'M avant vlxqs     ')
 
-      call vlxqs(zq,pente_max,zm,mu,qsat)
+      call vlxqs(zq,pente_max,zm,mu,qsat,iq)
 
 c     call minmaxq(zq,qmin,qmax,'apres vlxqs     ')
@@ -149,14 +153,31 @@
       DO l=1,llm
          DO ij=1,ip1jmp1
-           q(ij,l)=zq(ij,l)
+           q(ij,l,iq)=zq(ij,l,iq)
          ENDDO
          DO ij=1,ip1jm+1,iip1
-            q(ij+iim,l)=q(ij,l)
-         ENDDO
-      ENDDO
+            q(ij+iim,l,iq)=q(ij,l,iq)
+         ENDDO
+      ENDDO
+      ! CRisi: aussi pour les fils
+      if (nqdesc(iq).gt.0) then
+      do ifils=1,nqdesc(iq)
+        iq2=iqfils(ifils,iq)
+        DO l=1,llm
+         DO ij=1,ip1jmp1
+           q(ij,l,iq2)=zq(ij,l,iq2)
+         ENDDO
+         DO ij=1,ip1jm+1,iip1
+            q(ij+iim,l,iq2)=q(ij,l,iq2)
+         ENDDO
+        ENDDO
+      enddo !do ifils=1,nqdesc(iq)  
+      endif ! if (nqfils(iq).gt.0) then
+      !write(*,*) 'vlspltqs 183: fin de la routine'
 
       RETURN
       END
-      SUBROUTINE vlxqs(q,pente_max,masse,u_m,qsat)
+      SUBROUTINE vlxqs(q,pente_max,masse,u_m,qsat,iq)
+      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils ! CRisi
+
 c
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -175,8 +196,9 @@
 c   Arguments:
 c   ----------
-      REAL masse(ip1jmp1,llm),pente_max
+      REAL masse(ip1jmp1,llm,nqtot),pente_max
       REAL u_m( ip1jmp1,llm )
-      REAL q(ip1jmp1,llm)
+      REAL q(ip1jmp1,llm,nqtot)
       REAL qsat(ip1jmp1,llm)
+      INTEGER iq ! CRisi
 c
 c      Local 
@@ -191,4 +213,8 @@
       REAL adxqu(ip1jmp1),dxqmax(ip1jmp1,llm)
       REAL u_mq(ip1jmp1,llm)
+
+      ! CRisi
+      REAL masseq(ip1jmp1,llm,nqtot),Ratio(ip1jmp1,llm,nqtot)
+      INTEGER ifils,iq2 ! CRisi
 
       Logical first,testcpu
@@ -223,7 +249,7 @@
          DO l = 1, llm
             DO ij=iip2,ip1jm-1
-               dxqu(ij)=q(ij+1,l)-q(ij,l)
+               dxqu(ij)=q(ij+1,l,iq)-q(ij,l,iq)
 c              IF(u_m(ij,l).lt.0.) stop'limx n admet pas les U<0'
-c              sigu(ij)=u_m(ij,l)/masse(ij,l)
+c              sigu(ij)=u_m(ij,l)/masse(ij,l,iq)
             ENDDO
             DO ij=iip1+iip1,ip1jm,iip1
@@ -277,5 +303,5 @@
          DO l = 1, llm
             DO ij=iip2,ip1jm-1
-               dxqu(ij)=q(ij+1,l)-q(ij,l)
+               dxqu(ij)=q(ij+1,l,iq)-q(ij,l,iq)
             ENDDO
             DO ij=iip1+iip1,ip1jm,iip1
@@ -319,11 +345,11 @@
       DO l=1,llm
        DO ij=iip2,ip1jm-1
-          zdum(ij,l)=cvmgp(1.-u_m(ij,l)/masse(ij,l),
-     ,                     1.+u_m(ij,l)/masse(ij+1,l),
+          zdum(ij,l)=cvmgp(1.-u_m(ij,l)/masse(ij,l,iq),
+     ,                     1.+u_m(ij,l)/masse(ij+1,l,iq),
      ,                     u_m(ij,l))
           zdum(ij,l)=0.5*zdum(ij,l)
           u_mq(ij,l)=cvmgp(
-     ,                q(ij,l)+zdum(ij,l)*dxq(ij,l),
-     ,                q(ij+1,l)-zdum(ij,l)*dxq(ij+1,l),
+     ,                q(ij,l,iq)+zdum(ij,l)*dxq(ij,l),
+     ,                q(ij+1,l,iq)-zdum(ij,l)*dxq(ij+1,l),
      ,                u_m(ij,l))
           u_mq(ij,l)=u_m(ij,l)*u_mq(ij,l)
@@ -337,11 +363,11 @@
        DO ij=iip2,ip1jm-1
           IF (u_m(ij,l).gt.0.) THEN
-             zdum(ij,l)=1.-u_m(ij,l)/masse(ij,l)
+             zdum(ij,l)=1.-u_m(ij,l)/masse(ij,l,iq)
              u_mq(ij,l)=u_m(ij,l)*
-     $         min(q(ij,l)+0.5*zdum(ij,l)*dxq(ij,l),qsat(ij+1,l))
+     $         min(q(ij,l,iq)+0.5*zdum(ij,l)*dxq(ij,l),qsat(ij+1,l))
           ELSE
-             zdum(ij,l)=1.+u_m(ij,l)/masse(ij+1,l)
+             zdum(ij,l)=1.+u_m(ij,l)/masse(ij+1,l,iq)
              u_mq(ij,l)=u_m(ij,l)*
-     $         min(q(ij+1,l)-0.5*zdum(ij,l)*dxq(ij+1,l),qsat(ij,l))
+     $         min(q(ij+1,l,iq)-0.5*zdum(ij,l)*dxq(ij+1,l),qsat(ij,l))
           ENDIF
        ENDDO
@@ -412,7 +438,8 @@
                      i=ijq-(j-1)*iip1
 c   accumulation pour les mailles completements advectees
-                     do while(zu_m.gt.masse(ijq,l))
-                        u_mq(ij,l)=u_mq(ij,l)+q(ijq,l)*masse(ijq,l)
-                        zu_m=zu_m-masse(ijq,l)
+                     do while(zu_m.gt.masse(ijq,l,iq))
+                        u_mq(ij,l)=u_mq(ij,l)+q(ijq,l,iq)
+     &                          *masse(ijq,l,iq)
+                        zu_m=zu_m-masse(ijq,l,iq)
                         i=mod(i-2+iim,iim)+1
                         ijq=(j-1)*iip1+i
@@ -420,18 +447,20 @@
 c   ajout de la maille non completement advectee
                      u_mq(ij,l)=u_mq(ij,l)+zu_m*
-     &               (q(ijq,l)+0.5*(1.-zu_m/masse(ijq,l))*dxq(ijq,l))
+     &                  (q(ijq,l,iq)+0.5*(1.-zu_m/masse(ijq,l,iq))
+     &                  *dxq(ijq,l))
                   ELSE
                      ijq=ij+1
                      i=ijq-(j-1)*iip1
 c   accumulation pour les mailles completements advectees
-                     do while(-zu_m.gt.masse(ijq,l))
-                        u_mq(ij,l)=u_mq(ij,l)-q(ijq,l)*masse(ijq,l)
-                        zu_m=zu_m+masse(ijq,l)
+                     do while(-zu_m.gt.masse(ijq,l,iq))
+                        u_mq(ij,l)=u_mq(ij,l)-q(ijq,l,iq)
+     &                          *masse(ijq,l,iq)
+                        zu_m=zu_m+masse(ijq,l,iq)
                         i=mod(i,iim)+1
                         ijq=(j-1)*iip1+i
                      ENDDO
 c   ajout de la maille non completement advectee
-                     u_mq(ij,l)=u_mq(ij,l)+zu_m*(q(ijq,l)-
-     &               0.5*(1.+zu_m/masse(ijq,l))*dxq(ijq,l))
+                     u_mq(ij,l)=u_mq(ij,l)+zu_m*(q(ijq,l,iq)-
+     &               0.5*(1.+zu_m/masse(ijq,l,iq))*dxq(ijq,l))
                   ENDIF
                ENDDO
@@ -450,4 +479,25 @@
       ENDDO
 
+! CRisi: appel récursif de l'advection sur les fils.
+! Il faut faire ça avant d'avoir mis à jour q et masse
+      !write(*,*) 'vlspltqs 326: iq,nqfils(iq)=',iq,nqfils(iq) 
+      
+      if (nqfils(iq).gt.0) then  
+       do ifils=1,nqdesc(iq)
+         iq2=iqfils(ifils,iq)
+         DO l=1,llm
+          DO ij=iip2,ip1jm
+           ! On a besoin de q et masse seulement entre iip2 et ip1jm 
+           masseq(ij,l,iq2)=masse(ij,l,iq)*q(ij,l,iq)
+           Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
+          enddo   
+         enddo
+        enddo !do ifils=1,nqdesc(iq)
+        do ifils=1,nqfils(iq)
+         iq2=iqfils(ifils,iq)
+         call vlx(Ratio,pente_max,masseq,u_mq,iq2)
+        enddo !do ifils=1,nqfils(iq)
+      endif !if (nqfils(iq).gt.0) then
+! end CRisi
 
 c   calcul des tendances
@@ -455,16 +505,33 @@
       DO l=1,llm
          DO ij=iip2+1,ip1jm
-            new_m=masse(ij,l)+u_m(ij-1,l)-u_m(ij,l)
-            q(ij,l)=(q(ij,l)*masse(ij,l)+
+            new_m=masse(ij,l,iq)+u_m(ij-1,l)-u_m(ij,l)
+            q(ij,l,iq)=(q(ij,l,iq)*masse(ij,l,iq)+
      &      u_mq(ij-1,l)-u_mq(ij,l))
      &      /new_m
-            masse(ij,l)=new_m
+            masse(ij,l,iq)=new_m
          ENDDO
 c   Modif Fred 22 03 96 correction d'un bug (les scopy ci-dessous)
          DO ij=iip1+iip1,ip1jm,iip1
-            q(ij-iim,l)=q(ij,l)
-            masse(ij-iim,l)=masse(ij,l)
-         ENDDO
-      ENDDO
+            q(ij-iim,l,iq)=q(ij,l,iq)
+            masse(ij-iim,l,iq)=masse(ij,l,iq)
+         ENDDO
+      ENDDO
+
+      ! retablir les fils en rapport de melange par rapport a l'air:
+      ! On calcule q entre iip2+1,ip1jm -> on fait pareil pour ratio 
+      ! puis on boucle en longitude
+      if (nqdesc(iq).gt.0) then  
+       do ifils=1,nqdesc(iq)
+         iq2=iqfils(ifils,iq)  
+         DO l=1,llm
+          DO ij=iip2+1,ip1jm
+            q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
+          enddo
+          DO ij=iip1+iip1,ip1jm,iip1
+             q(ij-iim,l,iq2)=q(ij,l,iq2)
+          enddo ! DO ij=ijb+iip1-1,ije,iip1
+         enddo !DO l=1,llm
+        enddo !do ifils=1,nqdesc(iq)
+      endif !if (nqfils(iq).gt.0) then
 
 c     CALL SCOPY((jjm-1)*llm,q(iip1+iip1,1),iip1,q(iip2,1),iip1)
@@ -474,5 +541,7 @@
       RETURN
       END
-      SUBROUTINE vlyqs(q,pente_max,masse,masse_adv_v,qsat)
+      SUBROUTINE vlyqs(q,pente_max,masse,masse_adv_v,qsat,iq)
+      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils ! CRisi
+      USE comconst_mod, ONLY: pi
 c
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -486,6 +555,4 @@
 c
 c   --------------------------------------------------------------------
-      USE comconst_mod, ONLY: pi
-
       IMPLICIT NONE
 c
@@ -497,8 +564,9 @@
 c   Arguments:
 c   ----------
-      REAL masse(ip1jmp1,llm),pente_max
+      REAL masse(ip1jmp1,llm,nqtot),pente_max
       REAL masse_adv_v( ip1jm,llm)
-      REAL q(ip1jmp1,llm)
+      REAL q(ip1jmp1,llm,nqtot)
       REAL qsat(ip1jmp1,llm)
+      INTEGER iq ! CRisi
 c
 c      Local 
@@ -524,4 +592,7 @@
       SAVE sinlon,coslon,sinlondlon,coslondlon
       SAVE airej2,airejjm
+
+      REAL masseq(ip1jmp1,llm,nqtot),Ratio(ip1jmp1,llm,nqtot) ! CRisi
+      INTEGER ifils,iq2 ! CRisi
 c
 c
@@ -562,6 +633,6 @@
 
       DO i = 1, iim
-      airescb(i) = aire(i+ iip1) * q(i+ iip1,l)
-      airesch(i) = aire(i+ ip1jm- iip1) * q(i+ ip1jm- iip1,l)
+      airescb(i) = aire(i+ iip1) * q(i+ iip1,l,iq)
+      airesch(i) = aire(i+ ip1jm- iip1) * q(i+ ip1jm- iip1,l,iq)
       ENDDO
       qpns   = SSUM( iim,  airescb ,1 ) / airej2
@@ -571,5 +642,5 @@
 
       DO ij=1,ip1jm
-         dyqv(ij)=q(ij,l)-q(ij+iip1,l)
+         dyqv(ij)=q(ij,l,iq)-q(ij+iip1,l,iq)
          adyqv(ij)=abs(dyqv(ij))
       ENDDO
@@ -586,6 +657,6 @@
 
       DO ij=1,iip1
-         dyq(ij,l)=qpns-q(ij+iip1,l)
-         dyq(ip1jm+ij,l)=q(ip1jm+ij-iip1,l)-qpsn
+         dyq(ij,l)=qpns-q(ij+iip1,l,iq)
+         dyq(ip1jm+ij,l)=q(ip1jm+ij-iip1,l,iq)-qpsn
       ENDDO
 
@@ -705,9 +776,10 @@
        DO ij=1,ip1jm
          IF( masse_adv_v(ij,l).GT.0. ) THEN
-           qbyv(ij,l)= MIN( qsat(ij+iip1,l), q(ij+iip1,l )  +
-     ,      dyq(ij+iip1,l)*0.5*(1.-masse_adv_v(ij,l)/masse(ij+iip1,l)))
+           qbyv(ij,l)= MIN( qsat(ij+iip1,l), q(ij+iip1,l,iq )  +
+     ,      dyq(ij+iip1,l)*0.5*(1.-masse_adv_v(ij,l)
+     ,      /masse(ij+iip1,l,iq)))
          ELSE
-              qbyv(ij,l)= MIN( qsat(ij,l), q(ij,l) - dyq(ij,l) *
-     ,                   0.5*(1.+masse_adv_v(ij,l)/masse(ij,l)) )
+              qbyv(ij,l)= MIN( qsat(ij,l), q(ij,l,iq) - dyq(ij,l) *
+     ,                   0.5*(1.+masse_adv_v(ij,l)/masse(ij,l,iq)) )
          ENDIF
           qbyv(ij,l) = masse_adv_v(ij,l)*qbyv(ij,l)
@@ -716,11 +788,33 @@
 
 
+! CRisi: appel récursif de l'advection sur les fils.
+! Il faut faire ça avant d'avoir mis à jour q et masse
+      !write(*,*) 'vlyqs 689: iq,nqfils(iq)=',iq,nqfils(iq) 
+   
+      if (nqfils(iq).gt.0) then  
+       do ifils=1,nqdesc(iq)
+         iq2=iqfils(ifils,iq)
+         DO l=1,llm
+         DO ij=1,ip1jmp1
+           masseq(ij,l,iq2)=masse(ij,l,iq)*q(ij,l,iq)
+           Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)     
+          enddo   
+         enddo
+        enddo !do ifils=1,nqdesc(iq)
+
+        do ifils=1,nqfils(iq)
+         iq2=iqfils(ifils,iq)
+         !write(*,*) 'vlyqs 783: appel rec de vly, iq2=',iq2
+         call vly(Ratio,pente_max,masseq,qbyv,iq2)
+        enddo !do ifils=1,nqfils(iq)
+      endif !if (nqfils(iq).gt.0) then
+
       DO l=1,llm
          DO ij=iip2,ip1jm
-            newmasse=masse(ij,l)
+            newmasse=masse(ij,l,iq)
      &      +masse_adv_v(ij,l)-masse_adv_v(ij-iip1,l)
-            q(ij,l)=(q(ij,l)*masse(ij,l)+qbyv(ij,l)-qbyv(ij-iip1,l))
-     &         /newmasse
-            masse(ij,l)=newmasse
+            q(ij,l,iq)=(q(ij,l,iq)*masse(ij,l,iq)+qbyv(ij,l)
+     &         -qbyv(ij-iip1,l))/newmasse
+            masse(ij,l,iq)=newmasse
          ENDDO
 c.-. ancienne version
@@ -728,16 +822,16 @@
          convmpn=ssum(iim,masse_adv_v(1,l),1)/apoln
          DO ij = 1,iip1
-            newmasse=masse(ij,l)+convmpn*aire(ij)
-            q(ij,l)=(q(ij,l)*masse(ij,l)+convpn*aire(ij))/
+            newmasse=masse(ij,l,iq)+convmpn*aire(ij)
+            q(ij,l,iq)=(q(ij,l,iq)*masse(ij,l,iq)+convpn*aire(ij))/
      &               newmasse
-            masse(ij,l)=newmasse
+            masse(ij,l,iq)=newmasse
          ENDDO
          convps  = -SSUM(iim,qbyv(ip1jm-iim,l),1)/apols
          convmps = -SSUM(iim,masse_adv_v(ip1jm-iim,l),1)/apols
          DO ij = ip1jm+1,ip1jmp1
-            newmasse=masse(ij,l)+convmps*aire(ij)
-            q(ij,l)=(q(ij,l)*masse(ij,l)+convps*aire(ij))/
+            newmasse=masse(ij,l,iq)+convmps*aire(ij)
+            q(ij,l,iq)=(q(ij,l,iq)*masse(ij,l,iq)+convps*aire(ij))/
      &               newmasse
-            masse(ij,l)=newmasse
+            masse(ij,l,iq)=newmasse
          ENDDO
 c.-. fin ancienne version
@@ -752,5 +846,5 @@
 c        DO ij = 1,iip1
 c           q(ij,l)=newq
-c           masse(ij,l)=newmasse*aire(ij)
+c           masse(ij,l,iq)=newmasse*aire(ij)
 c        ENDDO
 c        convps=-SSUM(iim,qbyv(ip1jm-iim,l),1)
@@ -762,9 +856,24 @@
 c        DO ij = ip1jm+1,ip1jmp1
 c           q(ij,l)=newq
-c           masse(ij,l)=newmasse*aire(ij)
+c           masse(ij,l,iq)=newmasse*aire(ij)
 c        ENDDO
 c._. fin nouvelle version
       ENDDO
 
+      !write(*,*) 'vly 866'
+
+! retablir les fils en rapport de melange par rapport a l'air:
+      if (nqdesc(iq).gt.0) then  
+       do ifils=1,nqdesc(iq)
+         iq2=iqfils(ifils,iq)  
+         DO l=1,llm
+          DO ij=1,ip1jmp1
+            q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
+          enddo
+         enddo
+        enddo !do ifils=1,nqdesc(iq)
+      endif !if (nqfils(iq).gt.0) then
+      !write(*,*) 'vly 879'
+
       RETURN
       END
Index: trunk/LMDZ.COMMON/libf/dyn3d_common/covcont.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d_common/covcont.F90	(revision 1508)
+++ trunk/LMDZ.COMMON/libf/dyn3d_common/covcont.F90	(revision 1508)
@@ -0,0 +1,29 @@
+SUBROUTINE covcont (klevel,ucov, vcov, ucont, vcont )
+!
+!-------------------------------------------------------------------------------
+! Author: P. Le Van
+!-------------------------------------------------------------------------------
+! Purpose: Compute contravariant components from covariant components.
+!-------------------------------------------------------------------------------
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  INTEGER, INTENT(IN)  :: klevel                    !--- VERTICAL LEVELS NUMBER
+  REAL,    INTENT(IN)  :: ucov ( ip1jmp1,klevel )   !--- U COVARIANT WIND
+  REAL,    INTENT(IN)  :: vcov ( ip1jm  ,klevel )   !--- V COVARIANT WIND
+  REAL,    INTENT(OUT) :: ucont( ip1jmp1,klevel )   !--- U CONTRAVAR WIND
+  REAL,    INTENT(OUT) :: vcont( ip1jm  ,klevel )   !--- V CONTRAVAR WIND
+!===============================================================================
+!   Local variables:
+  INTEGER :: l
+!===============================================================================
+  DO l=1,klevel
+    ucont(iip2:ip1jm,l)=ucov(iip2:ip1jm,l) * unscu2(iip2:ip1jm)
+    vcont(   1:ip1jm,l)=vcov(   1:ip1jm,l) * unscv2(   1:ip1jm)
+  END DO
+
+END SUBROUTINE covcont
+
Index: trunk/LMDZ.COMMON/libf/dyn3d_common/dynetat0.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d_common/dynetat0.F90	(revision 1508)
+++ trunk/LMDZ.COMMON/libf/dyn3d_common/dynetat0.F90	(revision 1508)
@@ -0,0 +1,398 @@
+!
+! $Id $
+!
+SUBROUTINE dynetat0(fichnom,vcov,ucov,teta,q,masse,ps,phis,time0)
+
+      USE infotrac, only: tname, nqtot, zone_num, iso_indnum,&
+                          iso_num, phase_num, alpha_ideal, iqiso, &
+                          ok_isotopes, iqpere, tnat
+      use netcdf, only: nf90_open,NF90_NOWRITE,nf90_noerr,nf90_strerror, &
+                        nf90_get_var, nf90_inq_varid, nf90_inq_dimid, &
+                        nf90_inquire_dimension,nf90_close
+
+      use control_mod, only : planet_type, timestart
+      USE comvert_mod, ONLY: pa,preff
+      USE comconst_mod, ONLY: im,jm,lllm,daysec,dtvr, &
+     			rad,omeg,g,cpp,kappa,pi
+      USE logic_mod, ONLY: fxyhypb,ysinus
+      USE serre_mod, ONLY: clon,clat,grossismx,grossismy
+      USE temps_mod, ONLY: annee_ref,day_ref,itau_dyn, &
+      			start_time,day_ini,hour_ini
+      USE ener_mod, ONLY: etot0,ptot0,ztot0,stot0,ang0
+
+      IMPLICIT NONE
+
+!=======================================================================
+!
+! Read initial confitions file
+!
+!=======================================================================
+
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom2.h"
+  include "iniprint.h"
+
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=*), INTENT(IN) :: fichnom          !--- FILE NAME
+  REAL, INTENT(OUT) ::  vcov(iip1,jjm, llm)        !--- V COVARIANT WIND
+  REAL, INTENT(OUT) ::  ucov(iip1,jjp1,llm)        !--- U COVARIANT WIND
+  REAL, INTENT(OUT) ::  teta(iip1,jjp1,llm)        !--- POTENTIAL TEMP.
+  REAL, INTENT(OUT) ::     q(iip1,jjp1,llm,nqtot)  !--- TRACERS
+  REAL, INTENT(OUT) :: masse(iip1,jjp1,llm)        !--- MASS PER CELL
+  REAL, INTENT(OUT) ::    ps(iip1,jjp1)            !--- GROUND PRESSURE
+  REAL, INTENT(OUT) ::  phis(iip1,jjp1)            !--- GEOPOTENTIAL
+  REAL,INTENT(OUT) :: time0
+!===============================================================================
+!   Local Variables 
+  CHARACTER(LEN=256) :: msg, var, modname
+  INTEGER,PARAMETER :: length=100
+  INTEGER :: iq, fID, vID, idecal
+  REAL :: tab_cntrl(length) ! array containing run parameters
+  INTEGER :: ierr
+  CHARACTER(len=12) :: start_file_type="earth" ! default start file type
+
+  REAL,ALLOCATABLE :: time(:) ! times stored in start
+  INTEGER :: timelen ! number of times stored in the file
+  INTEGER :: indextime ! index of selected time
+  !REAL  hour_ini ! fraction of day of stored date. Equivalent of day_ini, but 0=<hour_ini<1
+
+  INTEGER :: edges(4),corner(4)
+  INTEGER :: i
+
+!-----------------------------------------------------------------------
+  modname="dynetat0"
+
+!  Open initial state NetCDF file
+  var=fichnom
+  CALL err(NF90_OPEN(var,NF90_NOWRITE,fID),"open",var)
+!
+  CALL get_var1("controle",tab_cntrl)
+
+      !!! AS: idecal is a hack to be able to read planeto starts...
+      !!!     .... while keeping everything OK for LMDZ EARTH
+      if ((planet_type.eq."generic").or.(planet_type.eq."mars")) then
+          write(lunout,*)'dynetat0 : Planeto-like start file'
+          start_file_type="planeto"
+          idecal = 4
+          annee_ref  = 2000
+      else
+          write(lunout,*)'dynetat0 : Earth-like start file'
+          idecal = 5
+          annee_ref  = tab_cntrl(5)
+      endif
+
+
+      im         = tab_cntrl(1)
+      jm         = tab_cntrl(2)
+      lllm       = tab_cntrl(3)
+      if (start_file_type.eq."earth") then
+        day_ref    = tab_cntrl(4)
+      else
+        day_ini    = tab_cntrl(4)
+        day_ref=0
+      endif
+      rad        = tab_cntrl(idecal+1)
+      omeg       = tab_cntrl(idecal+2)
+      g          = tab_cntrl(idecal+3)
+      cpp        = tab_cntrl(idecal+4)
+      kappa      = tab_cntrl(idecal+5)
+      daysec     = tab_cntrl(idecal+6)
+      dtvr       = tab_cntrl(idecal+7)
+      etot0      = tab_cntrl(idecal+8)
+      ptot0      = tab_cntrl(idecal+9)
+      ztot0      = tab_cntrl(idecal+10)
+      stot0      = tab_cntrl(idecal+11)
+      ang0       = tab_cntrl(idecal+12)
+      pa         = tab_cntrl(idecal+13)
+      preff      = tab_cntrl(idecal+14)
+!
+      clon       = tab_cntrl(idecal+15)
+      clat       = tab_cntrl(idecal+16)
+      grossismx  = tab_cntrl(idecal+17)
+      grossismy  = tab_cntrl(idecal+18)
+!
+      IF ( tab_cntrl(idecal+19).EQ.1. )  THEN
+        fxyhypb  = .TRUE.
+!        dzoomx   = tab_cntrl(25)
+!        dzoomy   = tab_cntrl(26)
+!        taux     = tab_cntrl(28)
+!        tauy     = tab_cntrl(29)
+      ELSE
+        fxyhypb = .FALSE.
+        ysinus  = .FALSE.
+        IF( tab_cntrl(idecal+22).EQ.1. ) ysinus = .TRUE. 
+      ENDIF
+
+      if (planet_type=="mars") then ! so far this is only for Mars
+        hour_ini = tab_cntrl(29)
+      else
+        hour_ini=0
+      endif
+
+      if (start_file_type.eq."earth") then
+        day_ini = tab_cntrl(30)
+        itau_dyn = tab_cntrl(31)
+        start_time = tab_cntrl(32)
+      else
+        day_ini=tab_cntrl(4)
+        itau_dyn=0
+        start_time=0
+      endif
+!   .................................................................
+!
+!
+  WRITE(lunout,*)trim(modname)//': rad,omeg,g,cpp,kappa ', &
+                     rad,omeg,g,cpp,kappa
+
+  CALL check_dim(im,iim,'im','iim')
+  CALL check_dim(jm,jjm,'jm','jjm')
+  CALL check_dim(llm,lllm,'llm','lllm')
+
+  CALL get_var1("rlonu",rlonu)
+  CALL get_var1("rlatu",rlatu)
+  CALL get_var1("rlonv",rlonv)
+  CALL get_var1("rlatv",rlatv)
+
+  CALL get_var2("cu"   ,cu)
+  CALL get_var2("cv"   ,cv)
+
+  CALL get_var2("aire" ,aire)
+  CALL get_var2("phisinit",phis)
+
+! read time axis
+      ierr = nf90_inq_varid (fID, "temps", vID)
+      IF (ierr .NE. nf90_noerr) THEN
+        write(lunout,*)"dynetat0: Le champ <temps> est absent"
+        write(lunout,*)"dynetat0: J essaie <Time>"
+        ierr = nf90_inq_varid (fID, "Time", vID)
+        IF (ierr .NE. nf90_noerr) THEN
+           write(lunout,*)"dynetat0: Le champ <Time> est absent"
+           write(lunout,*)trim(nf90_strerror(ierr))
+           CALL ABORT_gcm("dynetat0", "", 1)
+        ENDIF
+        ! Get the length of the "Time" dimension
+        ierr = nf90_inq_dimid(fID,"Time",vID)
+        ierr = nf90_inquire_dimension(fID,vID,len=timelen)
+        allocate(time(timelen))
+        ! Then look for the "Time" variable
+        ierr  =nf90_inq_varid(fID,"Time",vID)
+        ierr = nf90_get_var(fID, vID, time)
+        IF (ierr .NE. nf90_noerr) THEN
+           write(lunout,*)"dynetat0: Lecture echouee <Time>"
+           write(lunout,*)trim(nf90_strerror(ierr))
+           CALL ABORT_gcm("dynetat0", "", 1)
+        ENDIF
+      ELSE   
+        ! Get the length of the "temps" dimension
+        ierr = nf90_inq_dimid(fID,"temps",vID)
+        ierr = nf90_inquire_dimension(fID,vID,len=timelen)
+        allocate(time(timelen))
+        ! Then look for the "temps" variable
+        ierr = nf90_inq_varid (fID, "temps", vID)
+        ierr = nf90_get_var(fID, vID, time)
+        IF (ierr .NE. nf90_noerr) THEN
+           write(lunout,*)"dynetat0: Lecture echouee <temps>"
+           write(lunout,*)trim(nf90_strerror(ierr))
+           CALL ABORT_gcm("dynetat0", "", 1)
+        ENDIF
+      ENDIF
+
+! select the desired time
+      IF (timestart .lt. 0) THEN  ! default: we use the last time value
+        indextime = timelen
+      ELSE  ! else we look for the desired value in the time axis
+       indextime = 0
+        DO i=1,timelen
+          IF (abs(time(i) - timestart) .lt. 0.01) THEN
+             indextime = i
+             EXIT
+          ENDIF
+        ENDDO
+        IF (indextime .eq. 0) THEN
+          write(lunout,*)"Time", timestart," is not in " &
+                                            //trim(fichnom)//"!!"
+          write(lunout,*)"Stored times are:"
+          DO i=1,timelen
+             PRINT*, time(i)
+          ENDDO
+          CALL ABORT_gcm("dynetat0", "", 1)
+        ENDIF
+      ENDIF
+
+      if (planet_type=="mars") then
+        ! In start the absolute date is day_ini + hour_ini + time
+        ! For now on, in the GCM dynamics, it is day_ini + time0
+        time0 = time(indextime) + hour_ini
+        day_ini = day_ini + INT(time0)
+        time0 = time0 - INT(time0) ! time0 devient le nouveau hour_ini
+        hour_ini = time0
+      else
+        time0 = time(indextime) 
+      endif
+      
+      PRINT*, "dynetat0: Selected time ",time(indextime), &
+              " at index ",indextime
+      
+      DEALLOCATE(time)
+
+! read vcov
+  CALL get_var3v_t("vcov",vcov,indextime)
+
+! read ucov
+  CALL get_var3u_t("ucov",ucov,indextime)
+ 
+! read teta (same corner/edges as ucov)
+  CALL get_var3u_t("teta",teta,indextime)
+
+! read tracers (same corner/edges as ucov)
+  corner(1)=1
+  corner(2)=1
+  corner(3)=1
+  corner(4)=indextime
+  edges(1)=iip1
+  edges(2)=jjp1
+  edges(3)=llm
+  edges(4)=1
+  IF(nqtot.GE.1) THEN
+      DO iq=1,nqtot
+        ierr= nf90_inq_varid(fID,tname(iq),vID)
+        IF (ierr .NE. nf90_noerr) THEN
+           write(lunout,*)TRIM(modname)//": Tracer <"//TRIM(var)//"> is missing"
+           write(lunout,*)"         It is hence initialized to zero"
+           q(:,:,:,iq)=0.
+           IF (planet_type=="earth") THEN
+            !--- CRisi: for isotops, theoretical initialization using very simplified
+            !           Rayleigh distillation las.
+            IF(ok_isotopes.AND.iso_num(iq)>0) THEN
+             IF(zone_num(iq)==0) q(:,:,:,iq)=q(:,:,:,iqpere(iq))*tnat(iso_num(iq))    &
+             &             *(q(:,:,:,iqpere(iq))/30.e-3)**(alpha_ideal(iso_num(iq))-1)
+             IF(zone_num(iq)==1) q(:,:,:,iq)=q(:,:,:,iqiso(iso_indnum(iq),phase_num(iq)))
+            END IF
+           ENDIF
+        ELSE
+           ierr=nf90_get_var(fID,vID,q(:,:,:,iq),corner,edges)
+          IF (ierr .NE. nf90_noerr) THEN
+            write(lunout,*)"dynetat0: Lecture echouee pour " &
+                                      //trim(tname(iq))
+            write(lunout,*)trim(nf90_strerror(ierr))
+            CALL ABORT_gcm("dynetat0", "", 1)
+          ENDIF
+        ENDIF
+      ENDDO
+  ENDIF
+
+!read masse (same corner/edges as ucov)
+  CALL get_var3u_t("masse",masse,indextime)
+
+!read ps
+  CALL get_var2_t("ps",ps,indextime)
+
+  CALL err(NF90_CLOSE(fID),"close",fichnom)
+
+  if (planet_type/="mars") then
+    day_ini=day_ini+INT(time0) ! obsolete stuff ; 0<time<1 anyways
+    time0=time0-INT(time0)
+  endif
+
+
+  CONTAINS
+
+SUBROUTINE check_dim(n1,n2,str1,str2)
+  INTEGER,          INTENT(IN) :: n1, n2
+  CHARACTER(LEN=*), INTENT(IN) :: str1, str2
+  CHARACTER(LEN=256) :: s1, s2
+  IF(n1/=n2) THEN
+    s1='value of '//TRIM(str1)//' ='
+    s2=' read in starting file differs from parametrized '//TRIM(str2)//' ='
+    WRITE(msg,'(10x,a,i4,2x,a,i4)'),s1,n1,s2,n2
+    CALL ABORT_gcm(TRIM(modname),TRIM(msg),1)
+  END IF
+END SUBROUTINE check_dim
+
+
+SUBROUTINE get_var1(var,v)
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var1
+
+
+SUBROUTINE get_var2(var,v)
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var2
+
+SUBROUTINE get_var2_t(var,v,indextime)
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:)
+  INTEGER, INTENT(IN) :: indextime
+  corner(1)=1
+  corner(2)=1
+  corner(3)=indextime
+  edges(1)=iip1
+  edges(2)=jjp1
+  edges(3)=1
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v,corner,edges),"get",var)
+END SUBROUTINE get_var2_t
+
+
+SUBROUTINE get_var3(var,v) ! on U grid
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:,:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var3
+
+SUBROUTINE get_var3u_t(var,v,indextime) ! on U grid
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:,:)
+  INTEGER, INTENT(IN) :: indextime
+  corner(1)=1
+  corner(2)=1
+  corner(3)=1
+  corner(4)=indextime
+  edges(1)=iip1
+  edges(2)=jjp1
+  edges(3)=llm
+  edges(4)=1
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v,corner,edges),"get",var)
+END SUBROUTINE get_var3u_t
+
+SUBROUTINE get_var3v_t(var,v,indextime) ! on V grid
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:,:)
+  INTEGER, INTENT(IN) :: indextime
+  corner(1)=1
+  corner(2)=1
+  corner(3)=1
+  corner(4)=indextime
+  edges(1)=iip1
+  edges(2)=jjm
+  edges(3)=llm
+  edges(4)=1
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v,corner,edges),"get",var)
+END SUBROUTINE get_var3v_t
+
+SUBROUTINE err(ierr,typ,nam)
+  INTEGER,          INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
+  CHARACTER(LEN=*), INTENT(IN) :: typ    !--- TYPE OF OPERATION
+  CHARACTER(LEN=*), INTENT(IN) :: nam    !--- FIELD/FILE NAME
+  IF(ierr==NF90_NoERR) RETURN
+  SELECT CASE(typ)
+    CASE('inq');   msg="Field <"//TRIM(nam)//"> is missing"
+    CASE('get');   msg="Reading failed for <"//TRIM(nam)//">"
+    CASE('open');  msg="File opening failed for <"//TRIM(nam)//">"
+    CASE('close'); msg="File closing failed for <"//TRIM(nam)//">"
+  END SELECT
+  CALL ABORT_gcm(TRIM(modname),TRIM(msg),ierr)
+END SUBROUTINE err
+
+END SUBROUTINE dynetat0
